Version bump. Add confd file and make init file workable with list:set, bug #390129...
authorPeter Volkov <pva@gentoo.org>
Sat, 17 Dec 2011 03:30:59 +0000 (03:30 +0000)
committerPeter Volkov <pva@gentoo.org>
Sat, 17 Dec 2011 03:30:59 +0000 (03:30 +0000)
Package-Manager: portage-2.1.10.39/cvs/Linux x86_64

net-firewall/ipset/ChangeLog
net-firewall/ipset/files/ipset.confd [new file with mode: 0644]
net-firewall/ipset/files/ipset.initd-r2 [new file with mode: 0644]
net-firewall/ipset/ipset-6.10.ebuild [new file with mode: 0644]

index 17fbf7ade8cb67b810380771c2168575e4fac655..169eb877bca44f04aeaa646093ee5a348899c402 100644 (file)
@@ -1,6 +1,13 @@
 # ChangeLog for net-firewall/ipset
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/net-firewall/ipset/ChangeLog,v 1.56 2011/10/12 14:13:35 pva Exp $
+# $Header: /var/cvsroot/gentoo-x86/net-firewall/ipset/ChangeLog,v 1.57 2011/12/17 03:30:59 pva Exp $
+
+*ipset-6.10 (17 Dec 2011)
+
+  17 Dec 2011; Peter Volkov <pva@gentoo.org> +ipset-6.10.ebuild,
+  +files/ipset.confd, +files/ipset.initd-r2:
+  Version bump. Add confd file and make init file workable with list:set, bug
+  #390129 and bug #393243 by Andrew Savchenko.
 
   12 Oct 2011; Peter Volkov <pva@gentoo.org> ipset-6.9.1-r2.ebuild:
   On second thought drop USE=ipv6: userspace should work is the same
diff --git a/net-firewall/ipset/files/ipset.confd b/net-firewall/ipset/files/ipset.confd
new file mode 100644 (file)
index 0000000..aef7589
--- /dev/null
@@ -0,0 +1,8 @@
+# /etc/conf.d/ipset
+
+# Location in which ipset initscript will save set rules on 
+# service shutdown
+IPSET_SAVE="/var/lib/ipset/rules-save"
+
+# Save state on stopping ipset
+SAVE_ON_STOP="yes"
diff --git a/net-firewall/ipset/files/ipset.initd-r2 b/net-firewall/ipset/files/ipset.initd-r2
new file mode 100644 (file)
index 0000000..410269f
--- /dev/null
@@ -0,0 +1,61 @@
+#!/sbin/runscript
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-firewall/ipset/files/ipset.initd-r2,v 1.1 2011/12/17 03:30:59 pva Exp $
+
+extra_commands="save"
+
+IPSET_SAVE=${IPSET_SAVE:-/var/lib/ipset/rules-save}
+
+depend() {
+    before iptables ip6tables
+    use logger
+}
+
+checkconfig() {
+    if [ ! -f "${IPSET_SAVE}" ] ; then
+        eerror "Not starting ${SVCNAME}. First create some rules then run:"
+        eerror "/etc/init.d/${SVCNAME} save"
+        return 1
+    fi
+    return 0
+}
+
+start() {
+    checkconfig || return 1
+    ebegin "Loading ipset session"
+    ipset restore < "${IPSET_SAVE}"
+    eend $?
+}
+
+stop() {
+    # check if there are any references to current sets
+
+    if ! ipset list | gawk '
+        ($1 == "References:") { refcnt += $2 }
+        ($1 == "Type:" && $2 == "list:set") { set = 1 }
+        (scan) { if ($0 != "") setcnt++; else { scan = 0; set = 0 } }
+        (set && $1 == "Members:") {scan = 1}
+        END { if ((refcnt - setcnt) > 0) exit 1 }
+    '; then
+        eerror "ipset is in use, can't stop"
+        return 1
+    fi
+
+    if [ "${SAVE_ON_STOP}" = "yes" ] ; then
+        save || return 1
+    fi
+
+    ebegin "Removing kernel IP sets"
+    ipset flush
+    ipset destroy
+    eend $?
+}
+
+save() {
+    ebegin "Saving ipset session"
+    touch "${IPSET_SAVE}"
+    chmod 0600 "${IPSET_SAVE}"
+    ipset save > "${IPSET_SAVE}"
+    eend $?
+}
diff --git a/net-firewall/ipset/ipset-6.10.ebuild b/net-firewall/ipset/ipset-6.10.ebuild
new file mode 100644 (file)
index 0000000..6714e18
--- /dev/null
@@ -0,0 +1,110 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-firewall/ipset/ipset-6.10.ebuild,v 1.1 2011/12/17 03:30:59 pva Exp $
+
+EAPI="4"
+inherit autotools linux-info linux-mod
+
+# Maintainer: with version bump take a look on:
+# http://git.netfilter.org/cgi-bin/gitweb.cgi?p=ipset.git;a=commit;h=70fdf030545f00888bcebb5fca8243a6dccca95b
+
+DESCRIPTION="IPset tool for iptables, successor to ippool."
+HOMEPAGE="http://ipset.netfilter.org/"
+SRC_URI="http://ipset.netfilter.org/${P}.tar.bz2"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="modules"
+
+RDEPEND=">=net-firewall/iptables-1.4.4
+       net-libs/libmnl"
+DEPEND="${RDEPEND}"
+
+# configurable from outside, e.g. /etc/make.conf
+IP_NF_SET_MAX=${IP_NF_SET_MAX:-256}
+
+BUILD_TARGETS="modules"
+MODULE_NAMES_ARG="kernel/net/netfilter/ipset/:${S}/kernel/net/netfilter/ipset"
+MODULE_NAMES="xt_set(kernel/net/netfilter/ipset/:${S}/kernel/net/netfilter/)"
+for i in ip_set{,_bitmap_{ip{,mac},port},_hash_{ip{,port{,ip,net}},net,net{port,iface}},_list_set}; do
+       MODULE_NAMES+=" ${i}(${MODULE_NAMES_ARG})"
+done
+
+check_header_patch() {
+       if ! $(grep -q NFNL_SUBSYS_IPSET "${KV_DIR}/include/linux/netfilter/nfnetlink.h"); then
+               eerror "Sorry, but you have to patch kernel sources with the following patch:"
+               eerror " # cd ${KV_DIR}"
+               eerror " # patch -i ${S}/netlink.patch -p1"
+               eerror "You should recompile and run new kernel to avoid runtime errors."
+               die "Unpatched kernel"
+       fi
+}
+
+pkg_setup() {
+       get_version
+       CONFIG_CHECK="NETFILTER"
+       ERROR_NETFILTER="ipset requires NETFILTER support in your kernel."
+
+       build_modules=0
+       if use modules; then
+               kernel_is -lt 2 6 35 && die "${PN} requires kernel greater then 2.6.35."
+               if linux_config_src_exists && linux_chkconfig_builtin "MODULES" ; then
+                       if linux_chkconfig_present "IP_NF_SET" || \
+                               linux_chkconfig_present "IP_SET"; then #274577
+                               eerror "There is IP{,_NF}_SET or NETFILTER_XT_SET support in your kernel."
+                               eerror "Please either build ipset with modules USE flag disabled"
+                               eerror "or rebuild kernel without IP_SET support and make sure"
+                               eerror "there is NO kernel ip_set* modules in /lib/modules/<you_kernel>/... ."
+                               die "USE=modules and in-kernel ipset support detected."
+                       else
+                               einfo "Modular kernel detected. Gonna build kernel modules..."
+                               build_modules=1
+                       fi
+               else
+                       eerror "Nonmodular kernel detected, but USE=modules. Either build"
+                       eerror "modular kernel (without IP_SET) or disable USE=modules"
+                       die "Nonmodular kernel detected, will not build kernel modules"
+               fi
+       fi
+       [[ ${build_modules} -eq 1 ]] && linux-mod_pkg_setup
+}
+
+src_prepare() {
+       [[ ${build_modules} -eq 1 ]] && check_header_patch
+       eautoreconf
+}
+
+src_configure() {
+       econf \
+               --with-maxsets=${IP_NF_SET_MAX} \
+               --libdir="${EPREFIX}"/$(get_libdir) \
+               --with-ksource="${KV_DIR}" \
+               --with-kbuild="${KV_OUT_DIR}"
+}
+
+src_compile() {
+       einfo "Building userspace"
+       emake
+
+       if [[ ${build_modules} -eq 1 ]]; then
+               einfo "Building kernel modules"
+               set_arch_to_kernel
+               emake modules
+       fi
+}
+
+src_install() {
+       einfo "Installing userspace"
+       emake DESTDIR="${D}" install
+
+       if [[ ${build_modules} -eq 1 ]]; then
+               einfo "Installing kernel modules"
+               linux-mod_src_install
+       fi
+
+       newinitd ${FILESDIR}/ipset.initd-r2 ${PN}
+       newconfd ${FILESDIR}/ipset.confd ${PN}
+       keepdir /var/lib/ipset
+       find "${ED}" \( -name '*.la' -o -name '*.a' \) -exec rm -f '{}' +
+}